"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FluentAdFlowWidget = void 0;
Object.defineProperty(exports, "FluentAdFlowWidgetView", {
  enumerable: true,
  get: function () {
    return _fluentAdflowWidget.FluentAdFlowWidgetView;
  }
});
var _reactNative = require("react-native");
var _fluentAdflowWidget = require("./fluent-adflow-widget");
// Access the native module for FluentAdFlowAdsSdk
const FluentAdFlowSdk = _reactNative.NativeModules.FluentAdFlowAdsSdk ? _reactNative.NativeModules.FluentAdFlowAdsSdk : new Proxy({}, {
  get() {}
});

// Access the native AdvertisingManager directly
const AdvertisingManager = _reactNative.NativeModules.AdvertisingManager ? _reactNative.NativeModules.AdvertisingManager : new Proxy({}, {
  get() {}
});
class FluentAdFlowWidget {
  static retrieveIDFA = async () => {
    console.log('----------- retrieveIDFA method -----------');
    try {
      const idfa = await FluentAdFlowWidget.getAdvertisingId();
      console.log('Retrieved IDFA:', idfa);
    } catch (error) {
      //console.error('Error retrieving IDFA from App.tsx:', error);
    }
  };
  static init(apiKey, referer) {
    FluentAdFlowWidget.retrieveIDFA();
    return FluentAdFlowSdk.initSdk(apiKey, referer);
  }
  static getAdvertisingId() {
    return new Promise(resolve => {
      if (_reactNative.Platform.OS === 'android') {
        console.log('------------- Android GAID retrieving ----------------');
        AdvertisingManager.retrieveGAIDIfAvailable().then(gaid => {
          console.log('------------- Android GAID:', gaid);
          resolve(gaid || null); // Resolve with GAID or null
        }).catch(error => {
          console.error('Error retrieving GAID:', error);
          resolve(null); // Resolve with null in case of an error
        });
      } else if (_reactNative.Platform.OS === 'ios') {
        console.log('------------- iOS IDFA retrieving ----------------');
        AdvertisingManager.requestTrackingPermissionIfAvailable().then(idfa => {
          console.log('------------- iOS IDFA:', idfa);
          resolve(idfa || null);
        }).catch(error => {
          console.error('Error retrieving IDFA:', error);
          resolve(null);
        });
      } else {
        console.error('Unsupported platform');
        resolve(null);
      }
    });
  }
}
exports.FluentAdFlowWidget = FluentAdFlowWidget;
//# sourceMappingURL=index.js.map